/*  Copyright (C) 2013 Zoltán Nagy
 *  Created by Zoltán Nagy on 9/23/13.
 *
 *  This program is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program. If not, see <http://www.gnu.org/licenses/>.
 */
#ifndef __deductor_h__
#define __deductor_h__ 1

/*   std includes    */

/*   project headers   */
#include <bits/mc-deductor.h>
#include <bits/mc-basic-user.h>
#include <bits/duct-module.h>
#include <cxx/filesystem.h>

namespace duct {
  
  
  struct deductor_input
  {
    /*   path of the directory where the output and result is saved   */
    fs::path bundle_dir;
    
    /*   directory where the model files get saved    */
    fs::path model_dir;
    
    /*   directory where the output files of the basics_user get saved    */
    fs::path output_dir;
    
    /*   directory where the result files of the basics_user get saved    */
    fs::path result_dir;
    
    /*   name of the run    */
    std::string run_name;
  };

  
  /*   type alias for exporting modules   */
  using export_my_module = volatile export_module<void(const deductor_input&)>;
  
  
}   //   namespace duct



#endif
